<script>
    //import { getImageLinkfromjson } from '../helpers/nft_helper';
    //^^ Importing not working - somehow causing redirect to a 404
    //vv But defining inline works... WTF
    /**
     * @param {string} json_uri
     */
    export function getImageLinkfromjson(json_uri) {
        var url = '';
        try {
            var json = JSON.parse(json_uri);
            for (const key in json) {
                if (key == 'image') {
                    var temp = json[key];
                    break;
                }
                if (json[key].includes('ipfs')) {
                    var temp = json[key];
                    break;
                }
            }
            temp = temp.replace('/ipfs/', 'https://tradehands.peerplays.download/ipfs/');
            url = temp.replace('ipfs://', 'https://tradehands.peerplays.download/ipfs/');

            return url;
        } catch (error) {
            return '';
        }
    }

    export /**
     * @type {any}
     */
    let nft_assets;

    export let default_nft = {
        name: '<invalid data>',
        id: 'N/A',
        nft_metadata_id: 'N.A.?'
    };

    export /**
     * @type {any}
     */
    let nft = nft_assets.objects ? nft_assets.objects[nft_assets.id] : default_nft;
    export /**
     * @type {{name : any, symbol : any}}
     */
    let metadata = nft_assets.objects[nft.nft_metadata_id];

    export /**
     * @type {any}
     */
    let index = nft_assets.index;

    export /**
     * @type {any}
     */
    let names = nft_assets.names;

    export /**
     * @type {any}
     */
    let image_url = getImageLinkfromjson(nft.token_uri);

    /**
     * @param {string} id
     */
    export function id_or_name(id) {
        return id in names ? names[id] : id;
    }
</script>

<div class="h-full w-full">
    <div class=" flex w-full h-full justify-center">
        <div class="flex flex-col p-6 w-[500px] border border-solid border-gray-500 rounded">
            <div class="flex justify-between">
                <div class="font-bold">
                    <h3>
                        {metadata.symbol != undefined ? metadata.symbol : ''}
                        {index != undefined ? ' : ' + index : ''}
                    </h3>
                </div>
                <div>
                    <p>{'(' + nft.id + ')'}</p>
                </div>
            </div>
            <div class="flex justify-between pt-1">
                <div>
                    <h3>Series Name :</h3>
                </div>
                <div>
                    <a
                        href="/nft/m/{nft.nft_metadata_id.substring(0, 5) == '1.30.'
                            ? nft.nft_metadata_id.split('.')[2]
                            : nft.nft_metadata_id}"
                    >
                        <p>{metadata.name != undefined ? metadata.name : ''}</p>
                    </a>
                </div>
            </div>
            <div class="flex justify-center pt-4 pb-11"><hr class="w-full" /></div>

            <div class="flex justify-between py-1.5">
                <img src={image_url} alt="nft image" />
            </div>
            <div class="flex justify-between py-1.5">
                <div class="font-semibold">
                    <h3>ID</h3>
                </div>
                <div>
                    <a
                        href="/nft/{nft.id.substring(0, 5) == '1.31.'
                            ? nft.id.split('.')[2]
                            : nft.id}">{nft.id}</a
                    >
                </div>
            </div>
            <div class="flex justify-between py-1.5">
                <div class="font-semibold">
                    <h3>Metadata ID</h3>
                </div>
                <div>
                    <a
                        href="/nft/m/{nft.nft_metadata_id.substring(0, 5) == '1.30.'
                            ? nft.nft_metadata_id.split('.')[2]
                            : nft.nft_metadata_id}">{nft.nft_metadata_id}</a
                    >
                </div>
            </div>
            <div class="flex justify-between py-1.5">
                <div class="font-semibold">
                    <h3>Owner</h3>
                </div>
                <div>
                    <a
                        href="/u/{nft.owner.substring(0, 4) == '1.2.'
                            ? nft.owner.split('.')[2]
                            : nft.owner}">{id_or_name(nft.owner)}</a
                    >
                </div>
            </div>
            <div class="flex justify-between py-1.5">
                <div class="font-semibold">
                    <h3>Approved</h3>
                </div>
                <div>
                    <a
                        href="/u/{nft.approved.substring(0, 4) == '1.2.'
                            ? nft.approved.split('.')[2]
                            : nft.approved}">{id_or_name(nft.approved)}</a
                    >
                </div>
            </div>
            <div class="flex justify-between py-1.5">
                <div class="font-semibold">
                    <h3>Approved Operators</h3>
                </div>
                <div>
                    <p>{JSON.stringify(nft.approved_operators)}</p>
                </div>
            </div>
            <div class="flex flex-col py-1.5 pb-4">
                <div class="font-semibold py-5">
                    <h3>Token Data</h3>
                </div>
                <div>
                    <div>
                        <!-- <p>{JSON.stringify(nft.token_uri)}</p> -->
                        <textarea
                            disabled
                            class="block p-3 h-24 w-full text-sm text-gray-900 rounded-lg border border-gray-300 "
                            placeholder="Token URI text goes in here"
                        >
                            {JSON.stringify(nft.token_uri)}
                        </textarea>
                    </div>
                </div>
            </div>
            <div
                class="flex justify-center rounded-[10px] bg-blue-600 hover:bg-blue-800 cursor-pointer text-white py-1"
                style="border: 1px solid grey"
            >
                <div class="py-1.5">
                    <a
                        href="/nft/{nft.id.substring(0, 5) == '1.31.'
                            ? nft.id.split('.')[2]
                            : nft.id}"
                        class="font-semibold text-lg">View This NFT</a
                    >
                </div>
            </div>
        </div>
    </div>
</div>
